<?php

class FileManager{

    public function fetch_size($dir) {
        $size = $this->fetch_size_rekursiv($dir);
        $size += $this->fetch_database_size();
        return $size;
    }

    private function fetch_size_rekursiv($dir, $size = 0) {
        $olddir = getcwd();
        chdir($dir);
        $content = array_diff(scandir(getcwd()), array('.', '..'));
        foreach($content as $data) {
            if ( is_dir($data) && !$this->is_exclude(sprintf('%s/%s', getcwd(), $data))) {
                $size = $this->fetch_size_rekursiv($data, $size);
            }elseif(!$this->is_exclude(sprintf('%s/%s', getcwd(), $data))) {
                $size += filesize($data);
            }
        }
        chdir($olddir);
        return $size;
    }

    private function fetch_database_size() {
        $mysqli = new mysqli(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
        $db_size = 0;
        $q = $mysqli->query( 'SHOW TABLE STATUS');
        while($row = mysqli_fetch_array($q)) {
            $db_size += $row["Data_length"] + $row["Index_length"];
        }
        return $db_size;
    }

    public function fetch_list($dir) {
        $this->fetch_list_rekursiv($dir);
    }

    private function fetch_list_rekursiv($dir) {
        $olddir = getcwd();
        chdir($dir);
        $content = array_diff(scandir(getcwd()), array('.', '..'));
        $cwd = getcwd();
        echo( sprintf('%s/', $cwd) );
        foreach($content as $data) {
            $cwd = getcwd();
            if ( is_dir($data) && !$this->is_exclude(sprintf('%s/%s', $cwd, $data))) {
                echo("\n");
                $this->fetch_list_rekursiv($data);
            }elseif(!$this->is_exclude(sprintf('%s/%s', $cwd, $data))) {
                echo("\n");
                echo (sprintf('%s/%s', $cwd, $data));
            }
        }
        chdir($olddir);
    }

    public function download_file($path) {
        $path = urldecode($path);
        $realpath   =   str_split($path,strrpos($path, '/'));
        $realpath   =   $realpath[0];
        $file       =   $this->get_file_name($path);
        chdir($realpath);
        if (file_exists($file)) {
            header('Content-Description: File Transfer');
            header('Content-Type: application/octet-stream');
            header('Content-Disposition: attachment; filename="'.basename($file).'"');
            header('Expires: 0');
            header('Cache-Control: must-revalidate');
            header('Pragma: public');
            header('Content-Length: ' . filesize($file));
            readfile($file);
        } else {
            echo "ERROR: File ". $file . " not in " . getcwd();
        }
    }

    public function send_files() {
        $files = $_POST['files'];
        $box_url = $_POST['boxUrl'];

        $migrator_path = dirname(dirname(__FILE__));
        $root_dir = dirname(dirname(dirname($migrator_path)));

        $files_array = explode(",", $files);
        foreach ($files_array as $file) {
            $send_path = str_replace($root_dir, "", $file);
            $this->send_file($file, $box_url, $send_path);
        }
    }

    private function send_file($file, $box_url, $send_path) {
        $ziel_url = $box_url."/RAIDBOXES/migration/getfile.php";

        //$exec = sprintf("Send file %s to BOX %s with new path %s", $file,$ziel_url,$root_dir);
        //var_dump($exec);

        $path = urldecode($file);
        $realpath   =   str_split($path,strrpos($path, '/'));
        $realpath   =   $realpath[0];
        $file       =   $this->get_file_name($path);
        $current_dir = getcwd();
        chdir($realpath);
        if (file_exists($file)) {

            if (function_exists('curl_file_create')) {
                $cFile = curl_file_create($file);
            } else {
                $cFile = '@' . $file;
            }
            $ch = curl_init($ziel_url);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, array(
                'path' =>   $send_path,
                'file' =>   $cFile
                ));
            $result = curl_exec($ch);
            curl_close($ch);
            var_dump($result);
        } else {
            echo "ERROR: File ". $file . " not in " . getcwd();
        }
        chdir($current_dir);

    }

    private function get_file_name($path) {
        $file =   substr(strrchr($path, '/'), 1);
        return trim($file);
    }

    private function is_exclude_regex($dir_entry) {
        $DIRECTORY_EXCLUDES = array(
            'wp-content/backups/',
            'wp-content/backups-dup-pro/',
            'wp-content/backup-(.*)/',
            'wp-content/bps-backup/',
            'wp-content/envato-backups/',
            'wp-content/updraft/',
            'wp-content/vpbackups/',
            'wp-content/plugins/akeebabackupwp/app/backups/',
            'wp-content/uploads/backwpup-(.*)-(.*)/',
            'wp-content/(uploads/)backupwordpress-(.*)-backups/',
            'logs/'
        );
        global $root_dir;
        foreach ( $DIRECTORY_EXCLUDES as $value ) {
            if ( substr( $value, - 1 ) == "/" ) {
                $value = substr( $value, 0, - 1 );
            }
            $match = "/" . $root_dir . "\/" . str_replace( "/", "\/", $value ) . "/";
            if ( preg_match( $match, $dir_entry ) ) {
                return true;
            }
        }
        return false;
    }

    private function is_exclude($dir_entry) {

        global $root_dir;

        $root_index = $root_dir . "/index.php";
        $staging =	$root_dir . "/staging";

        $DIRECTORY_EXCLUDES = array(
            $root_index,
            $staging,
            '/msd/work/backup',
            '/wp-content/backup',
            '/wp-content/bps-backup',
            '/wp-content/envato-backups',
            '/wp-content/updraft',
            '/wp-content/vpbackups',
            '/wp-content/ai1wm-backups',
            '/wp-content/hostinger-page-cache',
            '/wp-content/mu-plugins',
            '/wp-content/plugins/akeebabackupwp/app/backups',
            '/wp-content/uploads/backwpup-',
            '/wp-content/backupwordpress-',
            '/wp-content/uploads/backupwordpress-',
            '/wp-content/force-strong-passwords',
            '/wp-content/wp-engine-common',
            '/wp-content/uploads/backup-guard/',
            '/wp-includes',
            '/wp-admin',
            '/rb-plugins/',
            'RAIDBOXES',
            '.ftpquota',
            '.md5sums',
            '.opcache',
            'sess_',
            'zend_cache--',
            'cgi-bin/',
            'access_log',
            'error_log',
            '/wp-content/cache',
            '/wp-content/uploads/cache',
            '/wp-content/gt-cache',
            'wp-links-opml.php',
            'wp-login.php',
            'wp-load.php',
            'wp-mail.php',
            'wp-settings.php',
            'wp-signup.php',
            'wp-settings.php',
            'wp-trackback.php',
            'xmlrpc.php',
            'wp-blog-header.php',
            'wp-comments-post.php',
            'wp-cron.php',
            'wp-activate.php',
            '/infinitewp/backups',
            'wp-snapshots/',
            'uploads/magictoolbox_cache/',
            'uploads/wc-logs/',
            'uploads/fw-backup/',
            '/.php',
            '/piwik'
        );


        foreach ( $DIRECTORY_EXCLUDES as $value ) {
            if ( strpos($dir_entry, $value) !== false ) {
                return true;
            }
        }
        return false;
    }
}